#if LIRC

#include "stdio.h"
#include "stdlib.h"
#include "string.h"
#include "lirc/lirc_client.h"
#include <gtk/gtk.h>
#include "fftv.h"


int lirc_fd;

typedef struct {
  char *lirc;
  char *cmds;
  char cmdsN;
} LI_FF;

typedef struct {
  char *cmd_state;
  LI_FF *li_ff;
  int li_ffN;
} LI_FF_STATE;

static LI_FF *li_ff=NULL;
static int li_ffN=0;

LI_FF_STATE li_ff_state[8];
int li_ff_stateN, li_ff_state_idx=0;

int open_lirc()
{
  if (lirc_fd)
    return lirc_fd;

  if((lirc_fd=lirc_init("fftv",1))==-1) {
     dbg("connection to lirc failed\n");
     return -1;
  }

  return lirc_fd;
}

void set_lirc_cmd_state(char *state_name)
{
  int i;

  if (!li_ff_stateN)
    return;

  for(i=0;i<li_ff_stateN;i++)
    if (!strcmp(li_ff_state[i].cmd_state,state_name)) {
      li_ff=li_ff_state[i].li_ff;
      li_ffN=li_ff_state[i].li_ffN;
      li_ff_state_idx=i;
      return;
    }
  return;
  p_err("state_name %s is not defined",state_name);
}

extern char *skip_spc(char *s), *to_spc(char *s);
int parse_stmt(char *ffname, int lno,  char *ss,char **cmd, u_char *count);
extern char *fftv_cmd_state_str;

static int init_li_ff(char *fname)
{
  FILE *fp;
  LI_FF_STATE *pli_ff_state=NULL;
  int lineno=0;
  char infname[256];
  char *fftv_lirc;

  if (li_ff) {
    free(li_ff);
    li_ff=NULL;
    li_ffN=0;
  }

  if ((fftv_lirc=getenv("FFTV_LIRC")))
    strcpy(infname,fftv_lirc);
  else
    sprintf(infname,"%s/%s",FFTV_LIRC,fname);

//  dbg("fname:%s\n",infname);
  if ((fp=fopen(infname,"r"))==NULL) {
    return 0;
  }

  while (!feof(fp)) {
    char line[128],*ss;
    int slen;

    bzero(line,sizeof(line));
    fgets(line,sizeof(line),fp);
    lineno++;

    ss=skip_spc(line);
    slen=strlen(ss);

    if (*ss=='#' || slen < 2)
      continue;

    if (ss[slen -1]=='\n')
      ss[slen-1]=0;


    if (*ss=='!') {
      ss=skip_spc(ss+1);

      if (!(*ss))
        p_err("Expect state name after !  %s\n",line);

      pli_ff_state=&li_ff_state[li_ff_stateN];
      bzero(pli_ff_state,sizeof(LI_FF_STATE));

      pli_ff_state->cmd_state=strdup(ss);
      li_ff_stateN++;
    } else {
      char *tt=to_spc(ss);
      char lircstr[32];
      int lircstrN=tt-ss;
      char *cmds,cmdsN;

      memcpy(lircstr,ss,lircstrN);
      lircstr[lircstrN]=0;

      pli_ff_state->li_ff=
        realloc(pli_ff_state->li_ff,sizeof(LI_FF)*(pli_ff_state->li_ffN+1));
      pli_ff_state->li_ff[pli_ff_state->li_ffN].lirc=strdup(lircstr);

      ss=skip_spc(tt);
      parse_stmt(fname,lineno,ss,&cmds,&cmdsN);
      pli_ff_state->li_ff[pli_ff_state->li_ffN].cmds=cmds;
      pli_ff_state->li_ff[pli_ff_state->li_ffN].cmdsN=cmdsN;
      pli_ff_state->li_ffN++;
    }
  }

  set_lirc_cmd_state(fftv_cmd_state_str);

  return 1;
}

int ExecCommand(char *cmd, int count);

int lirc_fetch()
{
  char *codeline=NULL;
  int rval=0;

  if (lirc_nextcode(&codeline)==0) {
    char code[20];
    int repeat;
    char keyname[20];
    char model[20];
    int i;

    dbg("---- %s",codeline);
    code[0]=model[0]=keyname[0]=0;
    sscanf(codeline,"%s %x %s %s",code,&repeat,keyname,model);



    if (!li_ff) {
      if (!init_li_ff(model) && !init_li_ff("default")) {
        goto ret;
      }
    }

    for(i=0;i<li_ffN;i++) {
      if (!strcmp(li_ff[i].lirc,keyname)) {
        ExecCommand(li_ff[i].cmds,li_ff[i].cmdsN);
        rval=1;
        goto ret;
      }
    }

    dbg("no command for keyname %s\n",keyname);
  }

ret:
  free(codeline);
  return rval;
}

#endif
