#include <unistd.h>
#include <X11/Xlib.h>
#include <gtk/gtk.h>

#include "reminder.h"

#include <string.h>
#include <ctype.h>

#include "tv-freq.h"
#include "fftv.h"
#include "xkey.h"
#include "vidstr.h"
#include "tv-win.h"

static CHANLIST *pch_monitor;
gboolean b_ch_monitor;
extern CHANLIST *pchan_current;

static void update_channel_monitor()
{
//  dbg("set_channel_pch_0 %x\n",pch_monitor);
  tv_audio_off();

  if (!TV_WIN_DISP_MODE_GRAB)
    tv_pic_off();

  set_channel_pch_0(pch_monitor);

  if (TV_WIN_DISP_MODE_GRAB) {
    int i;

    usleep(120000);

    fftv_read_frame();

    local_vwin(pchan_monitor->x,pchan_monitor->y,
               pchan_monitor->xl,pchan_monitor->yl);
  } else {
    local_vwin(pchan_monitor->x,pchan_monitor->y,
               pchan_monitor->xl,pchan_monitor->yl);

    usleep(200000);
    tv_pic_off();
  }

  set_channel_pch_0(pchan_current);

  usleep(120000);
  set_vwin();

  if (TV_WIN_DISP_MODE_GRAB) {
    fftv_read_frame();
  }

  tv_audio_on();
}

static gboolean timeout_channel_monitor(void *ptr)
{
  if (b_ch_monitor) {
    update_channel_monitor();
    return TRUE;
  }
  else
    return FALSE;
}


void swap_channel_monitor()
{
  pchan_monitor->xl = 160;
  pchan_monitor->yl = 120;
  set_vidstr_xy(pchan_monitor, 160, 120, win_xl - pchan_monitor->xl, 0);

  if (TV_WIN_DISP_MODE_GRAB)
    set_vwin();

  if (b_ch_monitor) {
    CHANLIST *tpch=pchan_current;

    pchan_current = pch_monitor;
    set_chan_idx(rno2chidx(pchan_current->rno));
    set_channel_chan_idx();

    pch_monitor = tpch;
    update_channel_monitor();
  } else {
    if (!pch_monitor)
      pch_monitor = pchan_current;
    b_ch_monitor = TRUE;
    update_channel_monitor();
    gtk_timeout_add(5000,timeout_channel_monitor,NULL);
  }
}


void toggle_channel_monitor()
{
  if (b_ch_monitor) {
    b_ch_monitor=FALSE;
    clr_vidstr(pchan_monitor);
    set_vwin();
  } else {
    swap_channel_monitor();
  }
}

void reset_channel_monitor()
{
  pch_monitor = NULL;
  b_ch_monitor = FALSE;
}

