// it may also be replaced by corner-stitch
#include <X11/Xlib.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include <string.h>
#include "fftv.h"
#include "tv-win.h"
#include "vidstr.h"

static void add_rect(int x0, int y0, int x1, int y1,
                     RECT *outRect, int *ourRectN)
{
     outRect[*ourRectN].x0 = x0;
     outRect[*ourRectN].y0 = y0;
     outRect[*ourRectN].x1 = x1;
     outRect[*ourRectN].y1 = y1;
     (*ourRectN)++;
}


// a - b
int not_rect(int ax0, int ay0, int ax1, int ay1,
              int bx0, int by0, int bx1, int by1,
              RECT *outRect)
{
   int outRectN = 0;

   // no overlap
   if (ax0>=bx1 || ax1<=bx0 || ay0>=by1 || ay1<=by0) {
        add_rect(ax0,ay0,ax1,ay1, outRect, &outRectN);
        return outRectN;
   }

   // a fully inside b
   if (ax0>=bx0 && ax1<=bx1 && ay0>=by0 && ay1<=by1) {
        return outRectN;
   }

   if (ay0 < by0) {
        add_rect(ax0,ay0,ax1,by0, outRect, &outRectN);
        ay0=by0;
   }
   if (ay1 > by1) {
        add_rect(ax0,by1,ax1,ay1, outRect, &outRectN);
        ay1=by1;
   }

   if (ax0 < bx0) {
        add_rect(ax0, ay0, bx0, ay1, outRect, &outRectN);
        ax0=bx0;
   }
   if (ax1 > bx1) {
        add_rect(bx1, ay0, ax1, ay1, outRect, &outRectN);
        ax1=bx1;
   }

   return outRectN;
}


void gen_disp_tile()
{
  int i;
  RECT trect[4];
  RECT *orect;
  int orectN, norectN;

  if (disp_rect)
    free(disp_rect);

  orect = malloc(sizeof(RECT));
  orect[0].x0 = 0;  orect[0].y0 = 0;
  orect[0].x1 = win_xl;  orect[0].y1 = win_yl;
  orectN = 1;

  for(i=0; i < vidstrN; i++) {
    int vx0 = vidstr[i].x - 1;
    int vy0 = vidstr[i].y - 1;
    int vx1 = vx0 + vidstr[i].xl + 1;
    int vy1 = vy0 + vidstr[i].yl + 1;

    norectN = orectN;

    int j;
    for(j=0; j<orectN; j++) {
      RECT trect[4];
      int trectN;

      if (orect[j].x0 < 0)
        continue;

      trectN = not_rect(orect[j].x0, orect[j].y0, orect[j].x1, orect[j].y1,
               vx0,vy0,vx1,vy1, trect);

      if (trectN>1) {
        orect = realloc(orect, sizeof(RECT) * (norectN + trectN -1));
      } else
      if (trectN==0) {
        orect[j].x0 = -1;
        continue;
      }

      orect[j] = trect[0];

      if (trectN > 1) {
        memcpy(&orect[norectN], &trect[1], sizeof(RECT) * (trectN-1));
        norectN+=trectN-1;
      }
    }

    orectN = norectN;
  }

  norectN = 0;
  for(i=0; i< orectN; i++) {
    if (orect[i].x0 >= 0)
      orect[norectN++]=orect[i];
  }


  disp_rect = orect;
  disp_rectN = norectN;
}
