#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/ioctl.h>
#include <sys/time.h>
#include <time.h>
#include <linux/videodev.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <dirent.h>
#include "gtk/gtk.h"
#include "tv-freq.h"
#include "fftv.h"
#include "vidstr.h"

static char *html_browser;

static char *get_browser_exec()
{
  static char browser_exec[256];
  char fftv_states_dir[256];

  get_fftv_states_dir(fftv_states_dir);

  sprintf(browser_exec, "%s/tv-schedule-html-brower", fftv_states_dir);
  return browser_exec;
}


void load_html_browser_conf()
{

  if (html_browser)
    return;

  char *browser_exec = get_browser_exec();

  FILE *fp;
  if ((fp=fopen(browser_exec,"r"))==NULL) {
    html_browser = "mozilla";
    return;
  }

  char buf[256];

  buf[0]=0;
  fgets(buf,sizeof(buf),fp);

  if (buf[strlen(buf)-1]=='\n')
      buf[strlen(buf)-1]=0;

  html_browser = strdup(buf);
}

void show_current_tv_schedule()
{
  char *tv_schedule_html = pchan_current->tv_schedule_html;
  char cmd[512];

  load_html_browser_conf();

  if (!tv_schedule_html || strlen(tv_schedule_html) < 5)
    return;

  sprintf(cmd, "%s %s &", html_browser, tv_schedule_html);

  system(cmd);
}

static GtkWidget *schedule_select_window;
static GtkWidget *entry_browser;

void close_schedule_select_window()
{
  gtk_widget_destroy(schedule_select_window);
}

static void cb_cancel()
{
  close_schedule_select_window();
}


static void cb_ok()
{
  const char *text_browser = gtk_entry_get_text(GTK_ENTRY(entry_browser));

  html_browser = strdup(text_browser);

  char *browser_exec = get_browser_exec();

  FILE *fp;
  if ((fp=fopen(browser_exec,"w"))) {
    fprintf(fp,"%s", html_browser);
    fclose(fp);
  }

  close_schedule_select_window();
}


void create_schedule_browser_select_window()
{
    GtkWidget *hbox_file, *hbox_format ;
    GtkWidget *label_file;

    load_html_browser_conf();

    schedule_select_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    gtk_container_set_border_width (GTK_CONTAINER (schedule_select_window), 10);

    g_signal_connect (G_OBJECT (schedule_select_window), "delete_event",
                        G_CALLBACK (cb_cancel), NULL);

    gtk_window_set_title (GTK_WINDOW (schedule_select_window), "Enter TV Schedule browser");

    GtkWidget *vbox = gtk_vbox_new (FALSE, 5);

    hbox_file = gtk_hbox_new (FALSE, 0);

    label_file = gtk_label_new("TV Schedule browser");
    gtk_box_pack_start (GTK_BOX (hbox_file), label_file, FALSE, TRUE, 0);

    entry_browser = gtk_entry_new ();

#if 0
    g_signal_connect (G_OBJECT (entry), "activate",
		      G_CALLBACK (enter_callback),
		      (gpointer) entry);
#endif
    gtk_entry_set_max_length (GTK_ENTRY (entry_browser), 128);
    gtk_entry_set_width_chars(GTK_ENTRY (entry_browser), 25);
    gtk_entry_set_text (GTK_ENTRY (entry_browser), html_browser);
//    gtk_widget_set_size_request(entry, 100,24);
    gtk_box_pack_start (GTK_BOX (hbox_file), entry_browser, FALSE, TRUE, 10);

    gtk_box_pack_start (GTK_BOX (vbox), hbox_file, TRUE, TRUE, 0);

    GtkWidget *separator_file = gtk_hseparator_new ();

    gtk_box_pack_start (GTK_BOX (vbox), separator_file, TRUE, TRUE, 3);

    hbox_format = gtk_hbox_new (FALSE, 0);

    GtkWidget *hbox_ok = gtk_hbox_new (TRUE, 0);

    GtkWidget *button_ok = gtk_button_new_with_label("OK");
    gtk_box_pack_start (GTK_BOX (hbox_ok), button_ok, TRUE, TRUE, 10);
    GtkWidget *button_cancel = gtk_button_new_with_label("Cancel");
    gtk_box_pack_start (GTK_BOX (hbox_ok), button_cancel, TRUE, TRUE, 10);

    g_signal_connect (GTK_OBJECT (button_ok), "clicked", G_CALLBACK (cb_ok), NULL);
    g_signal_connect (GTK_OBJECT (button_cancel), "clicked", G_CALLBACK (cb_cancel), NULL);

    gtk_box_pack_start (GTK_BOX (vbox), hbox_ok, TRUE, TRUE, 10);

    gtk_container_add (GTK_CONTAINER (schedule_select_window), vbox);

    gtk_widget_show_all (schedule_select_window);
}
